var sceneType = 1;
var userAgent = navigator.userAgent;
if (userAgent.indexOf('AlipayClient') > -1) {
	// 支付宝小程序的 JS-SDK 防止 404 需要动态加载，如果不需要兼容支付宝小程序，则无需引用此 JS 文件。
	document.writeln('<script src="https://appx/web-view.min.js"' + '>' + '<' + '/' + 'script>');
} else if (/QQ/i.test(userAgent) && /miniProgram/i.test(userAgent)) {
	// QQ 小程序
	document.write(
		'<script type="text/javascript" src="https://qqq.gtimg.cn/miniprogram/webview_jssdk/qqjssdk-1.0.0.js"><\/script>'
	);
} else if (/miniProgram/i.test(userAgent) && /micromessenger/i.test(userAgent)) {
	sceneType = 100;
	// 微信小程序 JS-SDK 如果不需要兼容微信小程序，则无需引用此 JS 文件。
	createScript("https://res.wx.qq.com/open/js/jweixin-1.4.0.js")
} else if (/toutiaomicroapp/i.test(userAgent)) {
	// 头条小程序 JS-SDK 如果不需要兼容头条小程序，则无需引用此 JS 文件。
	document.write(
		'<script type="text/javascript" src="https://s3.pstatp.com/toutiao/tmajssdk/jssdk-1.0.1.js"><\/script>');
} else if (/swan/i.test(userAgent)) {
	// 百度小程序 JS-SDK 如果不需要兼容百度小程序，则无需引用此 JS 文件。
	document.write(
		'<script type="text/javascript" src="https://b.bdstatic.com/searchbox/icms/searchbox/js/swan-2.0.18.js"><\/script>'
	);
} else if (/quickapp/i.test(userAgent)) {
	// quickapp
	document.write('<script type="text/javascript" src="https://quickapp/jssdk.webview.min.js"><\/script>');
}
// if (!/toutiaomicroapp/i.test(userAgent)) {
// 	document.querySelector('.post-message-section').style.visibility = 'visible';
// }
//引用qs库
createScript("https://cdn.bootcdn.net/ajax/libs/qs/6.9.4/qs.min.js");
function jumpToMiniProgramPage(url) {
	function getGUID() {
		return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function(
			c
		) {
			var r = (Math.random() * 16) | 0,
				v = c == "x" ? r : (r & 0x3) | 0x8;

			return v.toString(16);
		});
	}
	return new Promise((resolve, reject) => {
		var _uuid = getGUID();
		var {
			hash
		} = window.location;
		var href = location.href.split("#")[0];
		// 带给小程序页面的参数
		let defaultQuery = Qs.stringify({
			href,
			hash,
			uuid: _uuid,
		});
		// query参数连接符
		let joiner = url.indexOf("?") < 0 ? "?" : "&";
		// hashchange的监听事件
		var hashchangeFunc = (_) => {
			var {
				callback: result,
				uuid
			} = Qs.parse(location.hash.split("?")[1]);
			// 防止其他代码改变hash值影响到当前回调
			if (_uuid === uuid) {
				// 防止回调参数未取到
				try {
					result = decodeURIComponent(result);
					result = JSON.parse(result || "{}");
				} catch (e) {
					result = {};
				}
				var {
					errNo,
					errMsg,
					res
				} = result;
				if (errNo >= 0) {
					resolve(result);
				} else {
					reject(result);
				}
				// 由于小程序改变了页面的hash，需要返回
				history.back();
				// 移除当前hashchange的监听
				window.removeEventListener("hashchange", hashchangeFunc);
			}
		};
		
		// 跳转到对应页面, webview->小程序的通讯智能通过跳转小程序页面并且带入参数的方式
		// wx.miniProgram.reLaunch({
		// 	url: `${url}${joiner}${defaultQuery}`,
		// })
		wx.miniProgram.navigateTo({
			url: `${url}${joiner}${defaultQuery}`,
		});
		// 监听hash变更，由于小程序没有api去实现小程序->webview的通讯，只能通过改变页面的hash传递消息
		// 改变hash并不会导致webview刷新
		window.addEventListener("hashchange", hashchangeFunc);
	});
}
//js调用小程序
window.jsToApplet = function(params){
	var url = "/pages/msgNotice/msgNotice?v="+JSON.stringify(params);
	let msg = `\r\n\r\n当前location.href值为: ${location.href}\r\n并且马上返回上级页面防止url污染`;
	jumpToMiniProgramPage(url)
		.then(({
			errNo,
			errMsg,
			res
		}) => {
			// alert(`获取成功: ${JSON.stringify(res)}` + msg);
			// alert(JSON.stringify(ggApplet))
			if (ggApplet !== undefined && ggApplet.jsAppletUtil !== undefined && ggApplet.jsAppletUtil.appletCallJs !== undefined) {
				ggApplet.jsAppletUtil.appletCallJs(res);
			}
		})
		.catch(({
			errNo,
			errMsg,
			res
		}) => {
			// alert(`获取失败: ${errMsg}` + msg);
		});
}
if(sceneType == 100){//小程序调用
	window.nativeCallJs({isNativeStart: true,showSceneType: sceneType});
}
//测试调用
// setTimeout(()=>{
// 	let params = {
// 		funcType:1,
// 		name:"张三",
// 		age:20,
// 		height:183
// 	}
// 	jsToApplet(params);
// },5000);
/**
 * 创建webview按钮
 * @param {*} onClick 点击
 */
window.createWvBtnBack = function(onBtnBack){
	var wvDiv = document.getElementById("webview-wrapper");
	// var wvDiv = document.getElementById("Cocos3dGameContainer");
	if(wvDiv){
		var button = document.createElement("input");
		button.setAttribute("type", "button");
		// button.setAttribute("value", value);
		button.setAttribute("id", "btn_back");
		button.setAttribute("class", "btn_back");
		button.setAttribute("style", `
			position:absolute;
			top:10px;
			left:10px;
			width:64px;
			height:66px;
			background:url('btn_back.png') no-repeat;
		`);
		button.onclick = ()=>{
			wvDiv.removeChild(button);
			onBtnBack && onBtnBack();
		};
		wvDiv?.appendChild(button);
	}
}
